/*
 *	main.c
 *
 *	gIL[uǂ
 *
 *	* Fri Jul 20 01:20:28 JST 2007 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/*{{2007/07/23 P/EMU 48MHzΉΉ*/
	bP0_P0D_P07D = 1;
	/*}}2007/07/23 P/EMU 48MHzΉΉ*/

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	dimen_sel = 1;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			update();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */

	if(joy & TRG_SELECT) {
		exit(0);
	}
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

const BLOCK block_table[5/*type*/][4/*rot*/] = {
#define _ 0
#define O 1
	/* 0 */
	{{{_,_,_},
	  {O,O,O},
	  {_,_,_}},
	 {{_,O,_},
	  {_,O,_},
	  {_,O,_}},
	 {{_,_,_},
	  {O,O,O},
	  {_,_,_}},
	 {{_,O,_},
	  {_,O,_},
	  {_,O,_}}},
	/* 1 */
	{{{_,O,_},
	  {_,O,O},
	  {_,_,_}},
	 {{_,_,_},
	  {_,O,O},
	  {_,O,_}},
	 {{_,_,_},
	  {O,O,_},
	  {_,O,_}},
	 {{_,O,_},
	  {O,O,_},
	  {_,_,_}}},
	/* 2 */
	{{{O,_,_},
	  {_,O,O},
	  {_,_,_}},
	 {{_,_,O},
	  {_,O,_},
	  {_,O,_}},
	 {{_,_,_},
	  {O,O,_},
	  {_,_,O}},
	 {{_,O,_},
	  {_,O,_},
	  {O,_,_}}},
	/* 3 */
	{{{_,_,O},
	  {O,O,_},
	  {_,_,_}},
	 {{_,O,_},
	  {_,O,_},
	  {_,_,O}},
	 {{_,_,_},
	  {_,O,O},
	  {O,_,_}},
	 {{O,_,_},
	  {_,O,_},
	  {_,O,_}}},
	/* 4 */
	{{{_,O,_},
	  {O,_,O},
	  {_,_,_}},
	 {{_,O,_},
	  {_,_,O},
	  {_,O,_}},
	 {{_,_,_},
	  {O,_,O},
	  {_,O,_}},
	 {{_,O,_},
	  {O,_,_},
	  {_,O,_}}},
};

static const fixed smoke_scale[] = { fld(1.05),fld(1.25),fld(1.4),fld(1.5) };

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	static const unsigned char blink_tbl[] = { 3,3,3,3, 3,3,3,3, 2,1,0,1 };
	int blink = 0;
	int stat = 0;
	int fade = 3 * 2 + 1;
	//
	int x;
	int y;
	int spr;
	fixed s;
	fixed d;

	bg_init2();

	surface_clear(&surface, 3);
	do {
		schedule();
		memcpy(vbuff, bg, DISP_X * DISP_Y);

		s = fsin(fidiv(fimul(PI2, now % SEC(2)), SEC(2)));

		x = 25;
		y = 57;
		d = s;
		fmul_(d, fld(0.10));
		fadd_(d, fld(0.15));
		spr = SPR_FACE_0;
		switch((now / 3) % 19) {
		case 1: spr += 1;
		case 0:
		case 2: spr += 1;
		}
		sprite_draw2(x, y, spr, DRW_NOMAL, fld(1), fld(1), d);

		x = 32;
		y =  2;
		spr = SPR_LOGO_1;
		sprite_draw(x, y, spr, DRW_NOMAL);
		//
		x = 32 + 72;
		y =  2 + 16;
		d = s;
		fmul_(d, fld(0.25));
		fadd_(d, fld(0.50));
		spr = SPR_TSHIP;
		sprite_draw2(x, y, spr, DRW_NOMAL, fld(1), fld(1), d);
		//
		x = 32;
		y =  2;
		spr = SPR_LOGO_0;
		sprite_draw(x, y, spr, DRW_NOMAL);

		x = 58 + (4 * 10);
		y = 47;
		render_printf_framed(&render, x, y, 0x82, 0x002, "%02d", dimen_sel);
		render_printf_framed(&render, x, y, 0x82, blink_tbl[blink], "%2d", dimen_sel);
		blink = (blink + 1) % ARRAY_SIZE(blink_tbl);

		switch(stat) {
		case 0:
			render_rectangle_shadow(&render, 0, 0, DISP_X, DISP_Y, fade / 2, 3);
			fade--;
			if(!fade) {
				stat++;
			}
			break;
		case 1:
			if((dimen_sel >  1) && (joy & (TRG_LF | TRG_DN))) {
				dimen_sel--;
				blink = 0;
			}
			if((dimen_sel < 10) && (joy & (TRG_RI | TRG_UP))) {
				dimen_sel++;
				blink = 0;
			}
			if(joy & TRG_A) {
				stat++;
			}
			break;
		case 2:
			render_rectangle_shadow(&render, 0, 0, DISP_X, DISP_Y, fade / 2, 3);
			fade++;
			if(fade > 3 * 2 + 1) {
				stat++;
			}
			break;
		}
	} while(stat < 3);

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

/* dv: `_WAIT0ɂȂȂ悤!! */

#define FLOAT_WAIT	SEC(0.5)
#define LAND_WAIT	SEC(1.0)

#define MOVE_WAIT	move_wait()	/* 1` */
static int
move_wait()
{
	int wait = SEC(1.0);
	int dist;
	if(game.dimen >= 1) {
		wait -= SEC(0.1) * (game.dimen - 1);
	}
	dist = fist(game.dist);
	if(dist <= 1000) {
		wait -= SEC(0.5) * (1000 - dist) / 1000;
	}
	if(wait < 1) {
		wait = 1; /* Kv!! */
	}
	return wait;
}

#define BLOCK_TYPES	(block_types())	/* 2`5 */
static int
block_types()
{
	int types;
	switch(game.dimen) {
	case 1:  types = 2; break;
	case 2:  types = 3; break;
	case 3:  types = 4; break;
	default: types = 5; break;
	}
	return types;
}

static inline CELL*
cell_ptr(int col, int row)
{
	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		DIE();
	}
	return &game.field[row][col];
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int mag;
	int flag;
	int wait;
	int fade;

	/* Q[B */
	game_init();

	/* X^[g\B */
	mag = 0;
	wait = SEC(1.0);
	fade = 3 * 2;
	do {
		schedule();
		game_draw();
		mag_draw(START_X, START_Y, SPR_START, mag++);
		if(fade) {
			render_rectangle_shadow(&render, 0, 0, DISP_X, DISP_Y, fade / 2, 3);
			fade--;
		}
	} while(--wait);
	game.next_type = RND32_RANGE(seed, 0, BLOCK_TYPES);
	game.draw_flag |= DRAW_NEXT;

	for(;;) {
		/* Q[I[o[B */
		if(gameover_test()) {
			if(game.chain) {
				do {
					schedule();
					if(game.time) {
						game.time--;
					}
					flag = trion_action();
					game_draw();
				} while(flag);
				goto L_COIN;
			}
			goto L_GAMEOVER;
		}
		if(!game.time) {
			if(!game.chain) {
				goto L_GAMEOVER;
			}
		}

		/* ubNoB */
		game.block_type = game.next_type;
		game.block_rot = 0;
		game.block_col = 3;
		game.block_row = 0;
		game.next_type = RND32_RANGE(seed, 0, BLOCK_TYPES);
		game.draw_flag |= DRAW_BLOCK;
		//
		game.next_mag = 0;
		do {
			schedule();
			if(game.time) {
				game.time--;
			}
			trion_action();
			game_draw();
			game.next_mag++;
		} while(game.next_mag < MAG_TIME);

		/* OEړB */
		wait = FLOAT_WAIT;
		do {
			schedule();
			if(game.time) {
				game.time--;
			}
			block_action();
			trion_action();
			game_draw();
			if(land_test(game.block_col, game.block_row)) {
				goto L_LAND;
			}
			if(joy & PAD_DN) {
				break;
			}
		} while(--wait);
L_MOVE:
		/* EړB */
		for(;;) {
			wait = MOVE_WAIT;
			do {
				schedule();
				if(game.time) {
					game.time--;
				}
				block_action();
				trion_action();
				game_draw();
				if(land_test(game.block_col, game.block_row)) {
					goto L_LAND; /* ڒnԂ */
				}
				if(joy & PAD_DN) {
					break; /*  */
				}
			} while(--wait);
			game.block_row++;
		}
L_LAND:
		/* ڒnEړB */
		wait = LAND_WAIT;
		do {
			schedule();
			if(game.time) {
				game.time--;
			}
			block_action();
			trion_action();
			game_draw();
			if(!land_test(game.block_col, game.block_row)) {
				goto L_MOVE; /* Ԃ */
			}
			if(joy & TRG_DN) {
				break; /* ڒ */
			}
		} while(--wait);
		game.draw_flag &= ~DRAW_BLOCK;

		/* ̉B */
		schedule();
		if(game.time) {
			game.time--;
		}
		block_set(game.block_col, game.block_row);
		flag = trion_action();
		game_draw();
		if(flag) {
			continue; /* ̃ubNo */
		}
		if(!game.chain) {
			continue; /* ̃ubNo */
		}
L_COIN:
		game.chain = 0; /* WFbgˏI */

		/* RCωB */
		do {
			schedule();
			if(game.time) {
				game.time--;
			}
			flag = coin_action();
			game_draw();
		} while(flag);

		/* RC\EFCgB */
		wait = SEC(1.0);
		do {
			schedule();
			if(game.time) {
				game.time--;
			}
			game_draw();
			if(joy & TRG_AB) {
				break;
			}
		} while(--wait);

		game.coin = 0; /* RC\I */
	}
L_GAMEOVER:
	/* Q[I[o[oB */
	game.chain = 0;
	game.coin = 0;
	game.over = 1;
	wait = 0;
	fade = 0;
	do {
		schedule();
		flag = gameover_action();
		game_draw();
		sprite_draw(OWARI_X, OWARI_Y, SPR_OWARI, DRW_NOMAL);
		if(fade) {
			render_rectangle_shadow(&render, 0, 0, DISP_X, DISP_Y, fade / 2, 3);
			fade++;
		} else {
			if(wait >= SEC(1.0)) {
				if(joy & TRG_AB) {
					fade = 1;
				}
			}
			if(wait >= SEC(3.0)) {
				if(!flag) {
					fade = 1;
				}
			}
			wait++;
		}
	} while(fade < SEC(0.5));

	/* XRAvZB */
	game.score = (game.dimen - dimen_sel) * 1000;
	if(fist(game.dist) < 1000) {
		game.score += 1000 - fist(game.dist);
	}
	if(game.score > 99999) {
		game.score = 99999;
	}

	/* ʕ\B */
	do_result();

	/* nCXRAXVB */
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static const unsigned char dither_tbl[8][8] = {
	{ 0,32, 8,40, 2,34,10,42},
	{48,16,56,24,50,18,58,26},
	{12,44, 4,36,14,46, 6,38},
	{60,28,52,20,62,30,54,22},
	{ 3,35,11,43, 1,33, 9,41},
	{51,19,59,27,49,17,57,25},
	{15,47, 7,39,13,45, 5,37},
	{63,31,55,23,61,29,53,21},
};

void
bg_init1()
{
	SURFACE surf;
	RENDER rend;
	int x;
	int y;
	int c;
	fixed d;

	surf.w = BG_W;
	surf.h = BG_H;
	surf.vbuff = &bg[0][0];
	render_init_2d(&rend, &surf, 0, 0, 0, 0);

	for(y = 0; y < BG_H; y++) {
		for(x = 0; x < BG_W; x++) {
			d = fidiv(fimul(PI2, (x + y * 2) % BG_W), BG_W);
			d = fsin(d);			/* (-1.0)...(  1.0) */
			fiadd_(d, 1);			/* ( 0.0)...(  2.0) */
			fimul_(d, 32);			/* ( 0.0)...( 64.0) */
			c = fist(d);			/* (  0)...(64   ) */
			c += dither_tbl[y & 7][x & 7];	/* (0+0)...(64+63) */
			c = (c < 48) ? 2 : 3;
			render_point(&rend, BG_W - 1 - x, y, c);
		}
	}
}

void
bg_init2()
{
	int x;
	int y;
	int c;
	int spr;
	fixed d;

	for(y = 0; y < DISP_Y; y++) {
		for(x = 0; x < DISP_X; x++) {
			c = y;
			c += dither_tbl[y & 7][x & 7];
			c = (c < 96) ? 1 : 0;
			render_point(&render, x, y, c);
		}
	}

	x = 25;
	y = 57;
	d = fld(0.15);
	spr = SPR_BODY;
	sprite_draw2(x, y, spr, DRW_NOMAL, fld(1), fld(1), d);

	x = 115;
	y = 32;
	render_string_framed(&render, x, y, "", 0x80, 0x003);
	x -= 8;
	render_string_framed(&render, x, y, "", 0x80, 0x003);
	x -= 8;
	render_string_framed(&render, x, y, "", 0x80, 0x003);

	x = 38;
	y = 79;
	render_printf_framed(&render, x, y, 0x82, 0x002, "1P %05d", game.score);
	render_printf_framed(&render, x, y, 0x82, 0x003, "1P %5d", game.score);
	x = 90;
	render_printf_framed(&render, x, y, 0x82, 0x002, "HI %05d", hiscore);
	render_printf_framed(&render, x, y, 0x82, 0x003, "HI %5d", hiscore);

	x = 62;
	y = 59;
	render_string_framed(&render, x, y, "START [A]", 0x82, 0x003);
	y += 8;
	render_string_framed(&render, x, y, "EXIT [SEL]", 0x82, 0x003);

	x = 58;
	y = 47;
	render_string_framed(&render, x, y, "DIMENSION", 0x82, 0x003);

	memcpy(bg, vbuff, DISP_X * DISP_Y);
}

void
bg_init3()
{
	surface_clear(&surface, 3);
	sprite_draw(0, 0, SPR_RLT, DRW_NOMAL);

	memcpy(bg, vbuff, DISP_X * DISP_Y);
}

/****************************************************************************
 *	
 ****************************************************************************/

void
game_init()
{
	int i;

	memset(&game, 0, sizeof game);

	game.time = TIME_INIT;
	game.dimen = dimen_sel;
	game.dist = fld(1000); /* Jn̂1050ł͂Ȃ1000 */

	/* wiB */
	for(i = 0; i < BG_STAR_MAX; i++) {
		game.bg_star[i][0] = FRND_RANGE(seed, fld(8), fld(DISP_X-8));	/* x */
		game.bg_star[i][1] = FRND_RANGE(seed, fld(0), fld(DISP_Y));	/* y */
		game.bg_star[i][2] = FRND_RANGE(seed, fld(0.125), fld(0.25));	/* vy */
	}

	/* OiB */
	for(i = 0; i < FG_STAR_MAX; i++) {
		game.fg_star[i][0] = FRND_RANGE(seed, fld(8), fld(DISP_X-8));	/* x */
		game.fg_star[i][1] = FRND_RANGE(seed, fld(-DISP_Y), fld(0));	/* y */
		game.fg_star[i][2] = FRND_RANGE(seed, fld(0.75), fld(1.0));	/* vy */
	}

	/* wi摜쐬B */
	bg_init1();
}

/****************************************************************************
 *	
 ****************************************************************************/

void
game_draw()
{
	int i;
	int x;
	int y;
	int spr;
	fixed acc;
	fixed spd;

	/* Xs[hB */
	acc = game.bg_acc;
	if(acc) {
		if(fcom(acc, >, fld(0.1/**/))) {
			acc = fld(0.1/**/);
		}
		fsub_(game.bg_acc, acc);
		fadd_(game.bg_spd, acc);
	} else {
		fsub_(game.bg_spd, fld(0.05/**/));
	}
	if(fcom(game.bg_spd, <, fld(0.0))) {
		game.bg_spd = fld(0.0);
	}
	if(fcom(game.bg_spd, >, fld(10.0/**/))) {
		game.bg_spd = fld(10.0/**/);
	}
	spd = game.bg_spd; /* ̑x */
	if(fcom(spd, <, fld(0.5/**/))) {
		spd = fld(0.5/**/);
	}

	/* FDړB */
	fsub_(game.dist, fmul(game.bg_spd, fld(0.25/**/)));
	while(fcom(game.dist, <=, fld(0))) {
		fadd_(game.dist, fld(1050));
		if(game.dimen < 99) {
			game.dimen++;
			if(!game.over) {
				game.time += TIME_EXTEND;
				if(game.time > SEC(100)) {
					game.time = SEC(100);
				}
				obj_gen(OBJ_TYPE_DIMEN, 0, 0);
			}
		}
	}

	/* wiړAړB */
	fsub_(game.bg_pos, spd);
	while(fcom(game.bg_pos, <, fld(0.0))) {
		fadd_(game.bg_pos, fld(BG_H - DISP_Y));
	}
	//
	y = fist(game.bg_pos);
	memcpy(vbuff, bg[y], DISP_X * DISP_Y);

	/* wiړA`B */
	for(i = 0; i < BG_STAR_MAX; i++) {
		fadd_(game.bg_star[i][1], spd);
		fadd_(game.bg_star[i][1], game.bg_star[i][2]);
		while(fcom(game.bg_star[i][1], >=, fld(DISP_Y+8))) {
			fsub_(game.bg_star[i][1], fld(DISP_Y+16));
			game.bg_star[i][0] = FRND_RANGE(seed, fld(8), fld(DISP_X-8));
			game.bg_star[i][2] = FRND_RANGE(seed, fld(0.125), fld(0.25));
		}
		//
		x = fist(game.bg_star[i][0]);
		y = fist(game.bg_star[i][1]);
		spr = SPR_SSTAR_0 + (i & 1);
		sprite_draw(x, y, spr, DRW_NOMAL);
	}

	/* Q[W`B */
	gauge_draw();

	/* tB[h`B */
	field_draw();

	/* ubN`B */
	if(game.draw_flag & DRAW_BLOCK) {
		if(game.next_mag < MAG_TIME) {
			x = FIELD_X + CELL_SIZE * game.block_col + 10;
			y = FIELD_Y + CELL_SIZE * game.block_row + 10;
			spr = SPR_BLOCK_0 + game.block_type;
			mag_draw(x, y, spr, game.next_mag);
		} else {
			block_draw();
		}
	}

	/* IuWFNg`B */
	obj_draw();

	/* CtH[V`B */
	info_draw();

	/* OiړA`B */
	for(i = 0; i < FG_STAR_MAX; i++) {
		fadd_(game.fg_star[i][1], game.fg_star[i][2]);
		while(fcom(game.fg_star[i][1], >=, fld(DISP_Y+8))) {
			fsub_(game.fg_star[i][1], fld(DISP_Y+16));
			game.fg_star[i][0] = FRND_RANGE(seed, fld(8), fld(DISP_X-8));
			game.fg_star[i][2] = FRND_RANGE(seed, fld(0.75), fld(1.0));
		}
		//
		x = fist(game.fg_star[i][0]);
		y = fist(game.fg_star[i][1]);
		spr = SPR_MSTAR_0 + (now / 3 & 3);
		sprite_draw(x, y, spr, DRW_NOMAL);
	}

	/* NEXT`B */
	if(game.draw_flag & DRAW_NEXT) {
		x = NEXT_X;
		y = NEXT_Y;
		spr = SPR_NEXT_0 + game.next_type;
		mag_draw(x, y, spr, game.next_mag);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
field_draw()
{
	int x;
	int y;
	int spr;
	int col;
	int row;
	CELL* cell;
	fixed s;

	sprite_draw(0, 0, SPR_BG, DRW_NOMAL);

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			if(!cell->type) {
				continue;
			}
			x = FIELD_X + CELL_SIZE * col;
			y = FIELD_Y + CELL_SIZE * row - cell->ofs;
			spr = -1;
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				spr = SPR_BLOCK;
				break;
			case CELL_TYPE_BBLOCK:
				spr = SPR_BBLOCK;
				break;
			case CELL_TYPE_TRION:
				switch(cell->disp) {
				case TRION_DISP_BLOCK:
					spr = SPR_BLOCK;
					break;
				case TRION_DISP_TRION:
					spr = SPR_TRION_0 + (now / 3 & 3);
					break;
				default:
					DIE();
				}
				break;
			case CELL_TYPE_COIN:
				spr = SPR_COIN;
				break;
			default:
				DIE();
			}
			if(spr >= 0) {
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
	}

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			if(!cell->type) {
				continue;
			}
			x = FIELD_X + CELL_SIZE * col;
			y = FIELD_Y + CELL_SIZE * row;
			spr = -1;
			switch(cell->type) {
			case CELL_TYPE_TRION:
				switch(cell->stat) {
				case TRION_STAT_CENTER:
					if(cell->cnt >= 0) {
						x += 3;
						y += 3;
						spr = SPR_SMOKE;
						s = smoke_scale[cell->cnt];
						sprite_draw2(x, y, spr, DRW_NOMAL, s, s, 0);
					}
					break;
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_draw()
{
	static int dx;
	static int dy;
	//
	const BLOCK* const block = &block_table[game.block_type][game.block_rot];
	int x;
	int y;
	int dx2;
	int dy2;
	int col;
	int row;
	int col2;
	int row2;
	int spr;
	int land_col;
	int land_row;
	int trion_col;
	int trion_row;

	/* ubN}[J[`B */
	land_col = game.block_col;
	land_row = game.block_row;
	if(!land_test(land_col, land_row)) {
		do {
			land_row++;
		} while(!land_test(land_col, land_row));
		spr = SPR_BMARK_0 + (now / 3 & 3);
		for(row = 2; row >= 0; row--) {
			for(col = 0; col <= 2; col++) {
				if(!(*block)[row][col]) {
					continue;
				}
				col2 = land_col + col;
				row2 = land_row + row;
				x = FIELD_X + CELL_SIZE * col2;
				y = FIELD_Y + CELL_SIZE * row2;
				sprite_draw(x, y, spr, DRW_NOMAL);
			}
		}
		dx = dx ? 0 : (RND32(seed) & 2) - 1;
		dy = dy ? 0 : (RND32(seed) & 2) - 1;
	} else {
		dx = 0;
		dy = 0;
	}
	if(joy & PAD_DN) { /* ̓u𖳂 */
		dx = 0;
		dy = 0;
	}

	/* ubN`B */
	spr = SPR_BLOCK;
	for(row = 2; row >= 0; row--) {
		for(col = 0; col <= 2; col++) {
			if(!(*block)[row][col]) {
				continue;
			}
			col2 = game.block_col + col;
			row2 = game.block_row + row;
			x = FIELD_X + CELL_SIZE * col2 + dx;
			y = FIELD_Y + CELL_SIZE * row2 + dy;
			sprite_draw(x, y, spr, DRW_NOMAL);
		}
	}

	/* gI}[J[`B */
	block_set(land_col, land_row); /* ڒnʒuɈꎞIɎ̉ */
	for(row = 0; row <= 2; row++) {
		for(col = 0; col <= 2; col++) {
			if(!(*block)[row][col]) {
				continue;
			}
			col2 = land_col + col;
			row2 = land_row + row;
			for(trion_row = row2 - 1; trion_row <= row2 + 1; trion_row++) {
				for(trion_col = col2 - 1; trion_col <= col2 + 1; trion_col++) {
					if(trion_test(trion_col, trion_row)) {
						dx2 = dy2 = abs(((now / 3) & 3) - 2); /* {2,1,0,1} */
						spr = SPR_TMARK_0;
						for(row = trion_row - 1; row <= trion_row + 1; row += 2) {
							for(col = trion_col - 1; col <= trion_col + 1; col += 2) {
								x = FIELD_X + CELL_SIZE * col - dx2;
								y = FIELD_Y + CELL_SIZE * row - dy2;
								sprite_draw(x, y, spr, DRW_NOMAL);
								dx2 = -dx2;
								spr++;
							}
							dy2 = -dy2;
						}
						goto L10; /* ܂ */
					}
				}
			}
		}
	}
L10:	block_unset(land_col, land_row); /* ڒnʒu̎̉ */
}

/****************************************************************************
 *	
 ****************************************************************************/

void
mag_draw(int x, int y, int spr, int mag)
{
	fixed s;

	mag = MAG_TIME - mag;
	if(mag > 0) {
		s = fld(1.0);
		do {
			fmul_(s, MAG_UNIT);
		} while(--mag);
		sprite_draw2(x, y, spr, DRW_NOMAL, s, s, 0);
	} else {
		sprite_draw(x, y, spr, DRW_NOMAL);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
cell_set(CELL* cell, int type)
{
	memset(cell, 0, sizeof(CELL));
	cell->type = type;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
gameover_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = 0; row <= 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			if(cell->type) {
				return 1;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
move_test(int move_col, int move_row)
{
	const BLOCK* const block = &block_table[game.block_type][game.block_rot];
	int col;
	int row;
	int col2;
	int row2;

	for(row = 0; row <= 2; row++) {
		for(col = 0; col <= 2; col++) {
			if(!(*block)[row][col]) {
				continue;
			}
			col2 = move_col + col;
			row2 = move_row + row;
			if((col2 < 0) || (col2 > FIELD_COLS - 1) ||
			   (row2 < 0) || (row2 > FIELD_ROWS - 1)) {
				return 0;
			}
			if(game.field[row2][col2].type) {
				return 0;
			}
		}
	}

	return 1;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
land_test(int land_col, int land_row)
{
	if(!move_test(land_col, land_row)) {
		DIE();
	}

	return !move_test(land_col, land_row + 1);
}

/****************************************************************************
 *	
 ****************************************************************************/

int
trion_test(int trion_col, int trion_row)
{
	int result = 0; /* ȂƂubN܂߂1ɂȂ */
	//
	int col;
	int row;
	CELL* cell;

	for(row = trion_row - 1; row <= trion_row + 1; row++) {
		for(col = trion_col - 1; col <= trion_col + 1; col++) {
			if((col < 0) || (col > FIELD_COLS - 1) ||
			   (row < 0) || (row > FIELD_ROWS - 1)) {
				return 0;
			}
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				result = 1;
				break;
			case CELL_TYPE_TRION:
				/** no job **/
				break;
			default:
				return 0;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
trion_action()
{
	int i;
	int col;
	int row;
	int col2;
	int row2;
	CELL* cell;

	/* gIoB
	 * - gIdȂĕԏꍇÃׂubNɃgIɕωƁÃgIoł܂B
	 *   ̖h߂ɁAׂẴgIoĂA܂Ƃ߂āAubNgIωs܂B
	 */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			if(trion_test(col, row)) {
				for(row2 = row - 1; row2 <= row + 1; row2++) {
					for(col2 = col - 1; col2 <= col + 1; col2++) {
						cell = cell_ptr(col2, row2);
						switch(cell->type) {
						case CELL_TYPE_BLOCK:
							if((col2 == col) && (row2 == row)) {
								cell->stat = BLOCK_STAT_CENTER;
							} else if(!cell->stat) {
								cell->stat = BLOCK_STAT_TRION;
							}
							break;
						case CELL_TYPE_TRION:
							if((col2 == col) && (row2 == row)) {
								cell->stat = TRION_STAT_CENTER;
								cell->cnt = -1; /* _GtFNgҋ@ */
							}
							break;
						}
					}
				}
			}
		}
	}

	/* ubNgIωB */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				switch(cell->stat) {
				case BLOCK_STAT_CENTER:
					cell_set(cell, CELL_TYPE_TRION);
					cell->stat = TRION_STAT_CENTER;
					cell->cnt = -1; /* _GtFNgҋ@ */
					break;
				case BLOCK_STAT_TRION:
					cell_set(cell, CELL_TYPE_TRION);
					break;
				}
				break;
			}
		}
	}

	/* is̉_GtFNgpB */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_TRION:
				switch(cell->stat) {
				case TRION_STAT_CENTER:
					if(cell->cnt >= 0) {
						if(cell->cnt < ARRAY_SIZE(smoke_scale) - 1) {
							cell->cnt++;
							return 1; /* ܂ */
						} else {
							cell->stat = 0;
							for(row2 = row - 1; row2 <= row + 1; row2++) {
								for(col2 = col - 1; col2 <= col + 1; col2++) {
									cell = cell_ptr(col2, row2);
									if(cell->type != CELL_TYPE_TRION) {
										DIE();
									}
									cell->disp = TRION_DISP_TRION;
								}
							}
						}
					}
					break;
				}
				break;
			}
		}
	}

	/* VK̉_GtFNgJnB */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_TRION:
				switch(cell->stat) {
				case TRION_STAT_CENTER:
					if(cell->cnt < 0) {
						cell->cnt++;
						if(!cell->cnt) {
							game.chain++;
							game.fire_req++;
							if(game.chain >= 10) {
								obj_gen(OBJ_TYPE_LSTAR, col, row);
							}
							for(i = 0; i < 4; i++) {
								obj_gen(OBJ_TYPE_MSTAR, col, row);
							}
							fadd_(game.bg_acc, fld(1.0/**/));
						}
						return 1; /* ܂ */
					}
					break;
				}
				break;
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_action()
{
	static const char ofs[4][2/*x,y*/] = { {0,0},{-1,0},{+1,0},{0,-1} };
	//
	int i;
	int col;
	int row;
	int rot_add;

	rot_add = 0;
	if(joy & TRG_A) {
		rot_add = +1;
	}
	if(joy & TRG_B) {
		rot_add = -1;
	}
	if(rot_add) {
		game.block_rot = (game.block_rot + rot_add) & 3;
		for(i = 0; i < 4; i++) {
			col = game.block_col + ofs[i][0];
			row = game.block_row + ofs[i][1];
			if(move_test(col, row)) {
				game.block_col = col;
				game.block_row = row;
				break;
			}
		}
		if(i == 4) {
			game.block_rot = (game.block_rot - rot_add) & 3;
		}
	}

	if(joy & TRG_LF) {
		col = game.block_col - 1;
		if(move_test(col, game.block_row)) {
			game.block_col = col;
		}
	}
	if(joy & TRG_RI) {
		col = game.block_col + 1;
		if(move_test(col, game.block_row)) {
			game.block_col = col;
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_set(int block_col, int block_row)
{
	const BLOCK* const block = &block_table[game.block_type][game.block_rot];
	int col;
	int row;
	int col2;
	int row2;
	CELL* cell;

	for(row = 0; row <= 2; row++) {
		for(col = 0; col <= 2; col++) {
			if(!(*block)[row][col]) {
				continue;
			}
			col2 = block_col + col;
			row2 = block_row + row;
			cell = cell_ptr(col2, row2);
			if(cell->type) {
				DIE();
			}
			cell_set(cell, CELL_TYPE_BLOCK);
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_unset(int block_col, int block_row)
{
	const BLOCK* const block = &block_table[game.block_type][game.block_rot];
	int col;
	int row;
	int col2;
	int row2;
	CELL* cell;

	for(row = 0; row <= 2; row++) {
		for(col = 0; col <= 2; col++) {
			if(!(*block)[row][col]) {
				continue;
			}
			col2 = block_col + col;
			row2 = block_row + row;
			cell = cell_ptr(col2, row2);
			if(cell->type != CELL_TYPE_BLOCK) {
				DIE();
			}
			cell_set(cell, 0);
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
block_fix(int col, int row)
{
	CELL* cell;

	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return;
	}
	cell = cell_ptr(col, row);
	switch(cell->type) {
	case CELL_TYPE_BLOCK:
		switch(cell->stat) {
		case BLOCK_STAT_FLOAT:
			cell->stat = 0;
			block_fix(col, row - 1);
			block_fix(col, row + 1);
			block_fix(col - 1, row);
			block_fix(col + 1, row);
			break;
		}
		break;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

int
gameover_action()
{
	int flag = 0;
	//
	int i;
	int col;
	int row;
	CELL* cell;

	/* ubNubNωB */
	for(i = 0; i <= (FIELD_COLS - 1) + (FIELD_ROWS - 1); i++) {
		for(row = 0; row <= FIELD_ROWS - 1; row++) {
			for(col = 0; col <= FIELD_COLS - 1; col++) {
				if((col + row) != i) {
					continue;
				}
				cell = cell_ptr(col, row);
				switch(cell->type) {
				case CELL_TYPE_BLOCK:
					flag = 1;
					cell_set(cell, CELL_TYPE_BBLOCK);
					break;
				}
			}
		}
		if(flag) {
			return 1; /* ܂ */
		}
	}

	/* ubNŁB */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BBLOCK:
				cell_set(cell, 0);
				obj_gen(OBJ_TYPE_BBLOCK, col, row);
				return 1; /* ܂ */
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
coin_action()
{
	int flag = 0;
	//
	int i;
	int j;
	int col;
	int row;
	CELL* cell;
	CELL* cell2;
	unsigned char col_tbl[FIELD_COLS];

	/* _J쐬B */
	for(i = 0; i <= FIELD_COLS - 1; i++) {
		col_tbl[i] = i;
	}
	shuffle(col_tbl, FIELD_COLS, 1, &seed);

	/* gIRCωB */
	for(i = 0; i <= (FIELD_COLS - 1) + (FIELD_ROWS - 1); i++) {
		for(row = 0; row <= FIELD_ROWS - 1; row++) {
			for(col = 0; col <= FIELD_COLS - 1; col++) {
				if((col + row) != i) {
					continue;
				}
				cell = cell_ptr(col, row);
				switch(cell->type) {
				case CELL_TYPE_TRION:
					flag = 1;
					cell_set(cell, CELL_TYPE_COIN);
					/* RCubNŃ}[NB */
					j = FIELD_ROWS - row;
					do {
						switch(cell->type) {
						case CELL_TYPE_BLOCK:
							cell->stat = BLOCK_STAT_ERASE;
							break;
						}
						cell += FIELD_COLS;
					} while(--j);
					break;
				}
			}
		}
		if(flag) {
			return 1; /* ܂ */
		}
	}

	/* RCŁB */
	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(i = 0; i <= FIELD_COLS - 1; i++) {
			col = col_tbl[i];
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_COIN:
				game.coin++;
				cell_set(cell, 0);
				obj_gen(OBJ_TYPE_COIN, col, row);
				if(flag) {
					return 1; /* ܂ */
				} else {
					flag = 1;
				}
				break;
			}
		}
	}
	if(flag) {
		return 1; /* ܂ */
	}

	/* RCubNŁB */
	for(i = 0; i <= FIELD_COLS - 1; i++) {
		col = col_tbl[i];
		for(row = 0; row <= FIELD_ROWS - 1; row++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				switch(cell->stat) {
				case BLOCK_STAT_ERASE:
					flag = 1;
					cell_set(cell, 0);
					obj_gen(OBJ_TYPE_BLOCK, col, row);
					break;
				}
				break;
			}
		}
		if(flag) {
			return 1; /* ܂ */
		}
	}

	/* VubN}[NB */
	for(row = 0; row <= FIELD_ROWS - 1; row++) {
		for(col = 0; col <= FIELD_COLS - 1; col++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				if(!cell->stat) {
					cell->stat = BLOCK_STAT_FLOAT;
				}
				break;
			}
		}
	}
	for(col = 0; col <= FIELD_COLS - 1; col++) {
		block_fix(col, FIELD_ROWS - 1);
	}

	/* VubNJnB */
	for(i = 0; i <= FIELD_COLS - 1; i++) {
		col = col_tbl[i];
		for(row = 0; row <= FIELD_ROWS - 1; row++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				switch(cell->stat) {
				case BLOCK_STAT_FLOAT:
					flag = 1;
					cell->stat = BLOCK_STAT_FALL;
					cell->spd = 0;
				}
				break;
			}
		}
		if(flag) {
			flag = 0; /* Kv!! */
			break;
		}
	}

	/* VubNB */
	for(col = 0; col <= FIELD_COLS - 1; col++) {
		for(row = 0; row <= FIELD_ROWS - 1; row++) {
			cell = cell_ptr(col, row);
			switch(cell->type) {
			case CELL_TYPE_BLOCK:
				switch(cell->stat) {
				case BLOCK_STAT_FALL:
					flag = 1;
					if(cell->spd < CELL_SIZE) {
						cell->spd++;
					}
					cell->ofs -= cell->spd;
					if(cell->ofs < 0) {
						if(row == FIELD_ROWS - 1) {
							cell->stat = 0;
							cell->ofs = 0;
						} else {
							cell2 = cell_ptr(col, row + 1);
							if(cell2->type) {
								cell->stat = 0;
								cell->ofs = 0;
							} else {
								cell->ofs += CELL_SIZE;
								*cell2 = *cell;
								cell_set(cell, 0);
								row++; /* Kv!! */
							}
						}
					}
					break;
				}
				break;
			}
		}
	}
	if(flag) {
		return 1; /* ܂ */
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
obj_gen(int type, int col, int row)
{
	int i;
	OBJ* obj;

	for(i = 0; i < OBJ_MAX; i++) {
		obj = &game.objs[i];
		if(obj->type) {
			continue;
		}
		memset(obj, 0, sizeof(OBJ));
		obj->type = type;
		switch(type) {
		case OBJ_TYPE_FIRE:
			obj->x = fld(col);
			obj->y = fld(row);
			obj->vx = FRND_RANGE(seed, fld(-1.0), fld(+1.0));
			obj->vy = FRND_RANGE(seed, fld(+2.0), fld(+3.0));
			break;
		case OBJ_TYPE_BLOCK:
			obj->x = fld(FIELD_X + CELL_SIZE * col);
			obj->y = fld(FIELD_Y + CELL_SIZE * row);
			break;
		case OBJ_TYPE_BBLOCK:
			obj->x = fld(FIELD_X + CELL_SIZE * col);
			obj->y = fld(FIELD_Y + CELL_SIZE * row);
			break;
		case OBJ_TYPE_COIN:
			obj->x = fld(FIELD_X + CELL_SIZE * col);
			obj->y = fld(FIELD_Y + CELL_SIZE * row);
			obj->vy = FRND_RANGE(seed, fld(-4.0), fld(-3.0));
			break;
		case OBJ_TYPE_MSTAR:
			obj->x = fld(FIELD_X + CELL_SIZE * col + 3);
			obj->y = fld(FIELD_Y + CELL_SIZE * row + 3);
			obj->vx = FRND_RANGE(seed, fld(-3.0), fld(+3.0));
			obj->vy = FRND_RANGE(seed, fld(-0.4), fld(-0.2));
			fmul_(obj->vy, fld(row));
			fsub_(obj->vy, fld(2.0));
			break;
		case OBJ_TYPE_LSTAR:
			obj->x = fld(FIELD_X + CELL_SIZE * col + 3);
			obj->y = fld(FIELD_Y + CELL_SIZE * row + 3);
			obj->vx = FRND_RANGE(seed, fld(-3.0), fld(+3.0));
			obj->vy = FRND_RANGE(seed, fld(-0.4), fld(-0.2));
			fmul_(obj->vy, fld(row));
			fsub_(obj->vy, fld(2.0));
			break;
		case OBJ_TYPE_DIMEN:
			obj->x = fld(DIMEN_X);
			obj->y = fld(DIMEN_Y_MAX);
			obj->vy = fld(-1.0);
			break;
		default:
			DIE();
		}
		return; /* ܂ */
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
obj_draw()
{
	int type;
	int i;
	int x;
	int y;
	int c;
	int c1;
	int c2;
	int spr;
	int param;
	OBJ* obj;

	for(type = 1; type < OBJ_TYPES; type++) {
		for(i = 0; i < OBJ_MAX; i++) {
			obj = &game.objs[i];
			if(obj->type != type) {
				continue;
			}
			switch(obj->type) {
			case OBJ_TYPE_FIRE:
				fmul_(obj->vx, fld(0.9));
				fadd_(obj->x, obj->vx);
				fadd_(obj->y, obj->vy);
				spr = SPR_MSTAR_0 + (now / 3 & 3);
				break;
			case OBJ_TYPE_BLOCK:
				fadd_(obj->vy, fld(1.0));
				if(fcom(obj->vy, >, fld(CELL_SIZE))) {
					obj->vy = fld(CELL_SIZE);
				}
				fadd_(obj->y, obj->vy);
				spr = SPR_BLOCK;
				break;
			case OBJ_TYPE_BBLOCK:
				fadd_(obj->vy, fld(1.0));
				if(fcom(obj->vy, >, fld(CELL_SIZE))) {
					obj->vy = fld(CELL_SIZE);
				}
				fadd_(obj->y, obj->vy);
				spr = SPR_BBLOCK;
				break;
			case OBJ_TYPE_COIN:
				fadd_(obj->vy, fld(1.0));
				if(fcom(obj->vy, >, fld(CELL_SIZE))) {
					obj->vy = fld(CELL_SIZE);
				}
				fadd_(obj->y, obj->vy);
				spr = SPR_COIN;
				break;
			case OBJ_TYPE_MSTAR:
				fmul_(obj->vx, fld(0.95));
				fadd_(obj->x, obj->vx);
				if((fcom(obj->vx, <, fld(0)) && fcom(obj->x, <, fld(FIELD_X + CELL_SIZE *          0))) ||
				   (fcom(obj->vx, >, fld(0)) && fcom(obj->x, >, fld(FIELD_X + CELL_SIZE * FIELD_COLS)))) {
					fchs_(obj->vx);
				}
				fadd_(obj->vy, fld(0.25));
				if(fcom(obj->vy, >, fld(3.0))) {
					obj->vy = fld(3.0);
				}
				fadd_(obj->y, obj->vy);
				spr = SPR_MSTAR_0 + (now / 3 & 3);
				break;
			case OBJ_TYPE_LSTAR:
				fmul_(obj->vx, fld(0.95));
				fadd_(obj->x, obj->vx);
				if((fcom(obj->vx, <, fld(0)) && fcom(obj->x, <, fld(FIELD_X + CELL_SIZE *          0))) ||
				   (fcom(obj->vx, >, fld(0)) && fcom(obj->x, >, fld(FIELD_X + CELL_SIZE * FIELD_COLS)))) {
					fchs_(obj->vx);
				}
				fadd_(obj->vy, fld(0.25));
				if(fcom(obj->vy, >, fld(3.0))) {
					obj->vy = fld(3.0);
				}
				fadd_(obj->y, obj->vy);
				spr = SPR_LSTAR;
				break;
			case OBJ_TYPE_DIMEN:
				y = fist(obj->y);
				c1 = abs(y - DIMEN_Y_MIN);
				c2 = abs(y - DIMEN_Y_MAX);
				c = (c1 < c2) ? c1 : c2;
				param = (c <= 3) ? DRW_MASK(3 - c) : DRW_NOMAL;
				if(!obj->cnt) {
					x = fist(obj->x);
					spr = SPR_DIMEN;
					sprite_draw(x, y, spr, param);
				} else {
					x = NUM10_X;
					spr = SPR_NUM_0 + (game.dimen / 10);
					sprite_draw(x, y, spr, param);
					x = NUM01_X;
					spr = SPR_NUM_0 + (game.dimen % 10);
					sprite_draw(x, y, spr, param);
				}
				fadd_(obj->y, obj->vy);
				if(fcom(obj->y, <, fld(DIMEN_Y_MIN))) {
					if(!obj->cnt) {
						obj->cnt = 1;
						obj->y = fld(DIMEN_Y_MAX);
					} else {
						memset(obj, 0, sizeof(OBJ));
					}
				}
				goto L_NEXT; /* ܂ */
			default:
				DIE();
			}
			x = fist(obj->x);
			y = fist(obj->y);
			sprite_draw(x, y, spr, DRW_NOMAL);
			if(fcom(obj->y, >=, fld(DISP_Y))) {
				memset(obj, 0, sizeof(OBJ));
			}
L_NEXT:
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
info_draw()
{
	static const unsigned char c_tbl[] = { 1,2,3,3,2 };
	//
	int n;
	int c;

	n = (game.time + (FPS - 1)) / FPS;
	if(game.over || (n >= 10)) {
		c = 3;
	} else if(game.time) {
		c = c_tbl[(game.time / 3) % ARRAY_SIZE(c_tbl)];
	} else {
		c = c_tbl[now % ARRAY_SIZE(c_tbl)];
	}
	render_printf(&render,
		TIME_INFO_X,
		TIME_INFO_Y,
		0x82,
		c,
		"%03d",
		n);

	render_printf(&render,
		DIMEN_INFO_X,
		DIMEN_INFO_Y,
		0x82,
		3,
		"%02d",
		game.dimen);

	if(game.coin) {
		sprite_draw(
			COIN_X,
			COIN_Y,
			SPR_COIN,
			DRW_NOMAL);
		render_printf_framed(&render,
			COIN_NUM_X,
			COIN_NUM_Y,
			0x82,
			0x003,
			"%03d",
			game.coin);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
gauge_draw()
{
	int i;
	int y;
	int spr;
	fixed y0;
	fixed ofs;

	y0 = fsub(fld(SHIP_Y), fmul(game.bg_spd, fld(3.0/**/)));
	ofs = fidiv(fimul(game.dist, 4), 10);
	fsub_(y0, ofs);

	/*{{tXN[}*/
	{
		static fixed prev_y0;
		if(fcom(fsub(prev_y0, y0), >, fld(0.0)) &&
		   fcom(fsub(prev_y0, y0), <, fld(10.0/*K*/))) {
			y0 = prev_y0;
		} else {
			prev_y0 = y0;
		}
	}
	/*}}tXN[}*/

	y = fist(y0) + 4 * 104;
	for(i = 104; i >= 0; i--, y -= 4) {
		if((y < 0) || (y > DISP_Y - 1)) {
			continue;
		}
		switch(i % 10) {
		case 0:
			sprite_draw(
				LGAUGE_X,
				y,
				SPR_GAUGE,
				DRW_NOMAL);
			render_printf_framed(&render,
				LGAUGE_X - 4,
				y + 1,
				0x82,
				0x003,
				"%4d",
				i * 10);
			break;
		case 5:
			sprite_draw(
				MGAUGE_X,
				y,
				SPR_GAUGE,
				DRW_NOMAL);
			break;
		default:
			sprite_draw(
				SGAUGE_X,
				y,
				SPR_GAUGE,
				DRW_NOMAL);
			break;
		}
		switch(i) {
		case 0:
			sprite_draw(
				SHIP_X,
				y,
				SPR_GOAL,
				DRW_NOMAL);
			break;
		case 50:
			sprite_draw(
				SHIP_X,
				y,
				SPR_50PER,
				DRW_NOMAL);
			break;
		}
	}

	fadd_(y0, ofs);
	y = fist(y0);
	sprite_draw(
		SHIP_X,
		y,
		SPR_SHIP,
		DRW_NOMAL);
	if(game.chain) {
		y += 6;
		if(game.chain < 10) {
			spr = SPR_JET_0;
		} else if(game.chain < 20) {
			spr = SPR_JET_2;
		} else if(game.chain < 30) {
			spr = SPR_JET_4;
		} else {
			spr = SPR_JET_6;
		}
		spr += (now / 8) & 1;
		sprite_draw(
			SHIP_X,
			y,
			spr,
			DRW_NOMAL);
		if(game.fire_req) {
			y += 6;
			if(game.fire_cnt1 < SEC(0.25)) {
				game.fire_cnt1++;
			} else {
				if(game.fire_cnt2 < 10) {
					if(game.fire_cnt2 & 1) {
						obj_gen(OBJ_TYPE_FIRE, SHIP_X, y);
					}
					game.fire_cnt2++;
				} else {
					game.fire_req--;
					game.fire_cnt1 = 0;
					game.fire_cnt2 = 0;
				}
			}
		}
	} else {
		game.fire_req = 0;
		game.fire_cnt1 = 0;
		game.fire_cnt2 = 0;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static const short mes_pos[8+5+8][2/*x,y*/] = {
	{MES1_X+8*0,MES1_Y},{MES1_X+8*1,MES1_Y},{MES1_X+8*2,MES1_Y},{MES1_X+8*3,MES1_Y},{MES1_X+8*4,MES1_Y},{MES1_X+8*5,MES1_Y},{MES1_X+8*6,MES1_Y},{MES1_X+8*7,MES1_Y},
	{MES2_X+8*0,MES2_Y},{MES2_X+8*1,MES2_Y},{MES2_X+8*2,MES2_Y},{MES2_X+8*3,MES2_Y},{MES2_X+8*4,MES2_Y},
	{MES3_X+8*0,MES3_Y},{MES3_X+8*1,MES3_Y},{MES3_X+8*2,MES3_Y},{MES3_X+8*3,MES3_Y},{MES3_X+8*4,MES3_Y},{MES3_X+8*5,MES3_Y},{MES3_X+8*6,MES3_Y},{MES3_X+8*7,MES3_Y},
};
static short mes_spr[8+5+8] = {
	SPR_MES_KO,SPR_MES_N ,SPR_MES_KA,SPR_MES_I ,SPR_MES_NO,SPR_MES_SU,SPR_MES_KO,SPR_MES_A ,
	SPR_MES_0 ,SPR_MES_1 ,SPR_MES_2 ,SPR_MES_3 ,SPR_MES_4 ,
	SPR_MES_HA,SPR_MES_I ,SPR_MES_SU,SPR_MES_KO,SPR_MES_A ,SPR_MES_DE,SPR_MES_SU,SPR_MES_EX,
};

static void
mes_draw(int i, int cnt)
{
	fixed s = fld(1.0);
	fixed r = fld(0.0);
	int x;
	int y;
	int spr;

	if((i < 0) || (i > 8+5+8)) {
		DIE();
	}
	x = mes_pos[i][0];
	y = mes_pos[i][1];
	spr = mes_spr[i];

	if(cnt < 0) {
		return;
	}
	cnt = 10/**/ - cnt;
	if(cnt > 0) {
		do {
			fmul_(s, fld(1.1));
			fsub_(r, fld(0.4));
		} while(--cnt);
		sprite_draw2(x, y, spr, DRW_NOMAL, s, s, r);
	} else {
		sprite_draw(x, y, spr, DRW_NOMAL);
	}
}

typedef struct _KBN {
	short spr;
	fixed x;
	fixed y;
	fixed c;
	fixed s;
	fixed vc;
	fixed vs;
} KBN;
#define KBN_MAX (4+16)
static KBN kbns[KBN_MAX];

void
do_result()
{
	int stat = 0;
	int cnt = 0;
	int fade = 3 * 2 + 1;
	fixed meiou_x = fld(MEIOU_X + 48);
	fixed meiou_y = fld(MEIOU_Y + 48);
	fixed meiou_r = fld(0.0);
	int mes_cnt = -1;
	int mes_max;
	//
	int i;
	int x;
	int y;
	int spr;
	KBN* kbn;

	bg_init3();

	mes_spr[8+0] = SPR_MES_0 + (game.score / 10000 % 10);
	mes_spr[8+1] = SPR_MES_0 + (game.score /  1000 % 10);
	mes_spr[8+2] = SPR_MES_0 + (game.score /   100 % 10);
	mes_spr[8+3] = SPR_MES_0 + (game.score /    10 % 10);
	mes_spr[8+4] = SPR_MES_0 + (game.score /     1 % 10);
	if(game.score > hiscore) {
		mes_max = 8+5+8;
	} else {
		mes_max = 8+5;
	}

	for(i = KBN_MAX - 1; i >= 0; i--) {
		kbn = &kbns[i];
		kbn->spr = ((i < 4) ? SPR_KBN_0 : SPR_KBN_2) + (RND32(seed) & 1);
		kbn->x = FRND_RANGE(seed, fld(4.0), fld(80.0));
		kbn->y = fld(DISP_Y + 2);
		kbn->c = FRND_RANGE(seed, fld(0.0), fld(M_PI2));
		kbn->s = FRND_RANGE(seed, fld(0.0), fld(M_PI2));
		kbn->vc = FRND_RANGE(seed, fld(M_PI2/SEC(3)), fld(M_PI2/SEC(2)));
		kbn->vs = FRND_RANGE(seed, fld(M_PI2/SEC(3)), fld(M_PI2/SEC(2)));
		if(RND32(seed) & 1) fchs_(kbn->vc);
		if(RND32(seed) & 1) fchs_(kbn->vs);
	}

	surface_clear(&surface, 3);
	do {
		schedule();
		memcpy(vbuff, bg, DISP_X * DISP_Y);

		switch(stat) {
		case 0:
			if(cnt < SEC(0.75)) {
				cnt++;
				if(fade) {
					fade--;
				}
			} else {
				stat++;
				cnt = 0;
			}
			break;
		case 1:
			if(mes_cnt < 10 + mes_max * 2) {
				mes_cnt++;
			} else {
				meiou_x = fld(MEIOU_X);
				meiou_y = fld(MEIOU_Y);
				stat++;
				cnt = 0;
			}
			break;
		case 2:
			cnt++;
			if((cnt >= SEC(10)) || (joy & TRG_AB)) {
				stat++;
				cnt = 0;
			}
			break;
		case 3:
			if(fade < 3 * 2 + 1) {
				fade++;
			} else {
				stat++;
				cnt = 0;
			}
			break;
		}
		if(stat < 2) {
			if(joy & TRG_AB) {
				stat = 2;
				fade = 0;
				meiou_x = fld(MEIOU_X);
				meiou_y = fld(MEIOU_Y);
				mes_cnt = 10 + mes_max * 2;
				cnt = 0;
			}
		}

		for(i = KBN_MAX - 1; i >= 0; i--) {
			kbn = &kbns[i];
			spr = kbn->spr;
			x = fist(kbn->x);
			y = fist(kbn->y);
			x = fist(fsub(fsub(kbn->x, fmul(fcos(fchs(kbn->c)), fld(1.5))), fld(0.5)));
			y = fist(fsub(fsub(kbn->y, fmul(fsin(fchs(kbn->s)), fld(2.0))), fld(0.5)));
			sprite_draw(x, y, spr, DRW_NOMAL);
			if(stat < 2) {
				fadd_(kbn->c, kbn->vc);
				fadd_(kbn->s, kbn->vs);
			} else {
				fadd_(kbn->c, fimul(kbn->vc, 10));
				fadd_(kbn->s, fimul(kbn->vs, 10));
			}
			while(fcom(kbn->c, >=,      PI )) fsub_(kbn->c, PI2);
			while(fcom(kbn->c, < , fchs(PI))) fadd_(kbn->c, PI2);
			while(fcom(kbn->s, >=,      PI )) fsub_(kbn->s, PI2);
			while(fcom(kbn->s, < , fchs(PI))) fadd_(kbn->s, PI2);
		}

		for(i = 0; i < mes_max; i++) {
			mes_draw(i, mes_cnt - i*2);
		}

		meiou_x = fadd(fmul(fld(MEIOU_X), fld(0.1)), fmul(meiou_x, fld(0.9)));
		meiou_y = fadd(fmul(fld(MEIOU_Y), fld(0.1)), fmul(meiou_y, fld(0.9)));
		fadd_(meiou_r, fld(0.05));
		while(fcom(meiou_r, >=,      PI )) fsub_(meiou_r, PI2);
		while(fcom(meiou_r, < , fchs(PI))) fadd_(meiou_r, PI2);
		x = fist(fsub(fsub(meiou_x, fmul(fcos(fchs(meiou_r)), fld(3.0))), fld(0.5)));
		y = fist(fsub(fsub(meiou_y, fmul(fsin(fchs(meiou_r)), fld(3.0))), fld(0.5)));
		sprite_draw2(x, y, SPR_MEIOU, DRW_NOMAL, fld(1), fld(1), MEIOU_ROT);
		if(fade) {
			render_rectangle_shadow(&render, 0, 0, DISP_X, DISP_Y, fade / 2, 3);
		}
	} while(stat < 4);
}
